<template>
	<ProviderCustomColors
		:id="id"
		v-slot="{ customHeadingColorClass, customCopyColorClass }"
		:default-colors="{
			headingColor: 'white',
			copyColor: '#ffffff99',
			headingColorDesktop: 'white',
			copyColorDesktop: '#ffffff99',
		}"
		has-desktop-colors
		v-bind="getColorProps($props)"
	>
		<div
			:style="{
				'--padding-bottom': `${100 / (videoAspectRatioMobile || 16 / 9)}%`,
				'--padding-bottom-medium': `${100 / (videoAspectRatioDesktop || 16 / 9)}%`,
			}"
			:class="[
				$style.block,
				{
					[$style.spacing]: layout === 'spacing',
					[$style.hasMobileVideo]: hasMobileVideo,
					[$style.hasVideo]: hasVideo,
					[$style.hasAnimatedHeading]: headingAnimatedNormalized,
					[$style.playButtonLowerOnDesktop]: playButtonPositionOnDesktop === 'Lower',
					[$style.showIframe]: showIframe,
				},
			]"
		>
			<client-only>
				<div v-if="hasIframe" :class="$style.blockIframeWrapper">
					<iframe
						ref="videoIframe"
						v-lazy.iframe="{ src: videoDetails.url, critical, prefetch: false }"
						frameborder="0"
						:tabindex="showIframe ? '0' : '-1'"
						:title="`Embedded video: ${videoDetails.title}`"
						:aria-hidden="String(!showIframe)"
						allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture"
						allowfullscreen
						@lazyloaded="initializeTracking"
					></iframe>
				</div>
				<div ref="overlapTop" :class="[$style.overlap, $style.top]"></div>
				<div ref="overlayRight" :class="[$style.overlap, $style.right]"></div>
				<div ref="overlapBottom" :class="[$style.overlap, $style.bottom]"></div>
				<div ref="overlapLeft" :class="[$style.overlap, $style.left]"></div>
			</client-only>

			<div key="content" :style="copyColor && { color: copyColor }" :class="$style.contentWrapper">
				<div :class="$style.content">
					<BaseImage v-if="!hasMobileVideo || !hasVideo" v-bind="imageProps" />
					<div :class="$style.info">
						<div :class="[$style.heading, { [$style.hasMobile]: !!heading, [$style.hasDesktop]: !!headingDesktop }]">
							<template v-if="headingFadeOutEnabled">
								<MoleculeFadingTitle
									:class="[$style.headingInner, $style.mobile]"
									:delay="headingFadeOutDelay"
									:title="heading"
								/>
								<MoleculeFadingTitle
									:class="[$style.headingInner, $style.desktop]"
									:delay="headingFadeOutDelay"
									:title="headingDesktop"
								/>
							</template>
							<template v-else>
								<h2 :class="[$style.headingInner, $style.mobile]">{{ heading }}</h2>
								<h2 :class="[$style.headingInner, $style.desktop]">{{ headingDesktop }}</h2>
							</template>
						</div>

						<p v-if="description" :class="[$style.description, customCopyColorClass]" class="u-subheading">
							{{ description }}
						</p>

						<button
							v-if="videoModal && videoModal.html && (!playButtonText || (playButtonLink && playButtonLink.url))"
							ref="playButton"
							type="button"
							:class="$style.button"
							aria-label="Play video"
							@click="hasIframe ? playYtVideo() : () => {}"
						>
							<BaseIcon name="play" title="Play Video" width="24" height="24" />
						</button>
					</div>

					<div
						v-if="headingAnimatedNormalized && headingAnimatedNormalized.length"
						ref="headingsAnimatedContainer"
						:class="$style.headingsAnimated"
					>
						<div
							v-for="(text, index) in headingAnimatedNormalized"
							:key="index"
							:class="$style.headingAnimated"
							:data-visible="index === 0 && text.timingsParsed[0] === 0 ? 'true' : null"
						>
							<p :class="[$style.headingAnimatedText, customHeadingColorClass]">{{ text.text }}</p>
						</div>
					</div>

					<div
						v-if="(videoModal && videoModal.html && playButtonText) || (playButtonLink && playButtonLink.url)"
						:class="[$style.buttonWithTextWrapper, { [$style.hasLink]: playButtonLink && playButtonLink.url }]"
						:style="{ color: playButtonTextVariant === 'Outline' && playButtonTextColor }"
					>
						<BaseButton
							:ref="!(playButtonLink && playButtonLink.url) ? 'playButton' : 'playButtonCta'"
							:smart="playButtonLink && playButtonLink.url"
							:appearance="playButtonTextVariant"
							force-color
							size="medium"
							@click="hasIframe ? playYtVideo() : () => {}"
						>
							{{ playButtonText }}
						</BaseButton>
					</div>

					<ProviderElementActivityTracker v-if="hasVideo || hasMobileVideo" v-slot="{ isFocused }">
						<MoleculeAutoplayVideoPlayPause
							:class="[$style.videoWrapper, { [$style.hideBelowMedium]: !hasMobileVideo }]"
							:show-button="isFocused"
						>
							<iframe
								v-if="embedVideo"
								ref="videoIframe"
								v-lazy.video="videoBackgroundUrl"
								:style="{ backgroundImage: 'url(' + placeholderImage.url + ')' }"
								:data-src="hasVideo"
								:data-src-mobile="hasMobileVideo"
								:class="[{ 'js-video-critical': critical }]"
								frameborder="0"
								allow="autoplay"
								allowfullscreen
								webkitallowfullscreen
								mozallowfullscreen
								width="100%"
								height="100%"
							></iframe>
							<video
								v-else
								ref="video"
								v-lazy.video="videoUrl(videoBackgroundUrl)"
								:class="[$style.video, { 'js-video-critical': critical }]"
								:data-src="videoUrl(hasVideo)"
								:data-src-mobile="videoUrl(hasMobileVideo)"
								muted
								:loop="isLoop"
								playsinline
								:autoplay="isClient"
								@timeupdate="timeUpdate"
								@ended="($event) => $emit('video-ended', $event)"
							/>
						</MoleculeAutoplayVideoPlayPause>
					</ProviderElementActivityTracker>
				</div>
			</div>
		</div>
		<GlobalEvents v-if="hasVideo" target="window" @resize="debouncedAdjustOverlays" />
	</ProviderCustomColors>
</template>

<script>
import MoleculeFadingTitle from '@components/molecule-fading-title';
import ProviderCustomColors, { getColorProps } from '@components/provider-custom-colors';
import ProviderElementActivityTracker from '@components/provider-element-activity-tracker';
import MoleculeAutoplayVideoPlayPause from '@components/molecule-autoplay-video-play-pause';
import { mapState } from 'vuex';
import debounce from 'lodash/debounce';
import tealiumTrackYoutubeMixin from '@/mixins/tealium-track-youtube';
import extractAndAdjustVideoUrl from '@/utils/extract-and-adjust-video-url';

// Inline JS injected later:
//	(function() {
//		Array.prototype.slice.call(document.querySelectorAll('video.js-video-critical'))
//			.forEach(function(t) {
//				t.setAttribute('src', t.getAttribute(window.innerWidth >= 768 ? 'data-src' : 'data-src-mobile'));
//				t.play()
//			});
//	})();

function parseTextTracks(text) {
	const sections = text.split('\n\n');
	const parsedSections = sections
		.map((section) => {
			if (!section || !section.includes(' --> ')) return null;

			const lines = section.split('\n');
			const hasIdLine = !lines[0].includes(' --> ');
			const timingsLine = hasIdLine ? 1 : 0;
			const timings = lines[timingsLine].split(' --> ');
			const text = lines.slice(timingsLine + 1).join('\n');

			return {
				timings,
				timingsParsed: timings.map((time) => {
					const parts = time.split(':').reverse();
					const multipliers = [1, 60, 3600];

					return parts
						.map((part) => Number(part.replace(/,/g, '.')))
						.reduce((sum, part, index) => sum + part * (multipliers[index] || 0), 0);
				}),
				text,
			};
		})
		.filter(Boolean);

	return parsedSections.sort(({ timingsParsed: [aStart] }, { timingsParsed: [bStart] }) => aStart - bStart);
}

export default {
	components: {
		ProviderCustomColors,
		MoleculeFadingTitle,
		ProviderElementActivityTracker,
		MoleculeAutoplayVideoPlayPause,
	},

	mixins: [tealiumTrackYoutubeMixin],

	props: {
		id: {
			type: String,
			default: null,
		},

		layout: {
			type: String,
			default: '',
		},

		isLoop: {
			type: Boolean,
			default: true,
		},

		heading: {
			type: String,
			default: '',
		},

		headingDesktop: {
			type: String,
			default: '',
		},

		headingDesktopAnimated: {
			type: String,
			default: '',
		},

		headingFadeOutEnabled: {
			type: Boolean,
			default: false,
		},

		headingFadeOutDelay: {
			type: Number,
			default: 3000,
		},

		headingColor: {
			type: String,
			default: '',
		},

		copyColor: {
			type: String,
			default: '',
		},

		headingColorDesktop: {
			type: String,
			default: '',
		},

		copyColorDesktop: {
			type: String,
			default: '',
		},

		description: {
			type: String,
			default: '',
		},

		videoBackgroundMobile: {
			type: Object,
			default: () => ({}),
		},

		videoBackground: {
			type: Object,
			default: () => ({}),
		},

		videoAspectRatioMobile: {
			type: Number,
			default: 16 / 9,
		},

		videoAspectRatioDesktop: {
			type: Number,
			default: 16 / 9,
		},

		videoModal: {
			type: Object,
			default: null,
		},

		imageBackground: {
			type: Object,
			default: () => ({}),
		},

		playButtonPositionOnDesktop: {
			type: String,
			default: 'Default',
		},

		critical: {
			type: Boolean,
			default: false,
		},

		playButtonText: {
			type: String,
			default: '',
		},

		playButtonTextColor: {
			type: String,
			default: '',
		},

		playButtonTextVariant: {
			type: String,
			default: '',
		},

		playButtonLink: {
			type: Object,
			default: null,
		},

		useNocookieUrl: {
			type: Boolean,
			default: false,
		},

		playerParameters: {
			type: String,
			default: '',
		},

		embedVideo: {
			type: Boolean,
			default: false,
		},

		embedVideoBackground: {
			type: Object,
			default: null,
		},

		embedVideoBackgroundMobile: {
			type: Object,
			default: null,
		},

		placeholderImage: {
			type: Object,
			default: () => ({}),
		},
	},

	data() {
		return {
			showIframe: false,
			debouncedAdjustOverlays: debounce(this.adjustOverlays, 100),
			initializedTracking: false,
		};
	},

	head: {
		script: [
			{
				hid: 'block-video-faster-init',
				type: 'text/javascript',
				innerHTML: `
					Array.prototype.slice.call(document.querySelectorAll('video.js-video-critical'))
						.forEach(function(t) {
							t.setAttribute('src', t.getAttribute(window.innerWidth >= 768 ? 'data-src' : 'data-src-mobile'));
              t.play()
						});
				`,
				body: true,
			},
		],
		__dangerouslyDisableSanitizersByTagID: {
			'block-video-faster-init': ['innerHTML'],
		},
	},

	computed: {
		...mapState('screen', ['medium']),

		videoTrackingName() {
			return `Video - ${(this.heading || '').replace(/\n/g, ' ').replace(/ +/g, ' ')}`;
		},

		hasMobileVideo() {
			const { videoBackgroundMobile, embedVideo, embedVideoBackgroundMobile } = this;
			if (embedVideo) {
				return embedVideoBackgroundMobile && embedVideoBackgroundMobile.url;
			}
			return videoBackgroundMobile && videoBackgroundMobile.url;
		},

		hasVideo() {
			const { videoBackground, embedVideo, embedVideoBackground } = this;
			if (embedVideo) {
				return embedVideoBackground && embedVideoBackground.url;
			}
			return videoBackground && videoBackground.url;
		},

		videoBackgroundUrl() {
			if (this.showIframe) return '';
			const { medium } = this;
			if (medium && this.hasVideo) {
				return this.hasVideo;
			} else if (!medium && this.hasMobileVideo) {
				return this.hasMobileVideo;
			}

			return '';
		},

		imageProps() {
			return {
				image: this.imageBackground,
				images: this.hasVideo ? { medium: null } : {},
				critical: this.critical,
				fit: true,
				compressionLevel: 'medium',
				sizes: '100vw',
			};
		},

		videoDetails() {
			if (process.server) return null;
			const { videoModal } = this;
			if (!(videoModal && videoModal.html)) return videoModal;
			return {
				...extractAndAdjustVideoUrl(videoModal.html, {
					autoplay: false,
					useNocookieUrl: this.useNocookieUrl,
					playerParams: this.playerParameters,
				}),
				title: videoModal.title,
			};
		},

		hasIframe() {
			const { videoDetails } = this;
			return videoDetails && videoDetails.url;
		},

		headingAnimatedNormalized() {
			const { headingDesktopAnimated: headingAnimated, hasVideo, hasMobileVideo } = this;
			if (!headingAnimated || (!hasVideo && !hasMobileVideo)) return null;
			return parseTextTracks(headingAnimated);
		},

		isClient: () => process.client,
	},

	mounted() {
		if (this.$refs.video && !this.$refs.video.autoplay) {
			this.$refs.video.play();
		}

		this.$nextTick(this.adjustOverlays);
	},

	beforeDestroy() {
		if (this.tealiumVideoDestroy) {
			this.tealiumVideoDestroy();
		}
	},

	methods: {
		getColorProps,

		adjustOverlays() {
			const { playButton } = this.$refs;
			const { overlapTop, overlayRight, overlapBottom, overlapLeft } = this.$refs;
			const playButtonEl = (playButton && playButton.$el) || playButton;

			if (!(playButtonEl && playButtonEl.offsetParent && overlapTop && overlayRight && overlapBottom && overlapLeft)) {
				return;
			}

			const px = (val) => `${val}px`;
			const playButtonOffsetParent = playButtonEl.offsetParent;
			const getWithParent = (prop) => playButtonEl[`offset${prop}`] + playButtonOffsetParent[`offset${prop}`];

			const top = getWithParent('Top');
			overlapTop.style.height = px(top);
			const leftPx = px(getWithParent('Left'));
			overlayRight.style.width = leftPx; // assuming button is centered
			const bottom = playButtonOffsetParent.offsetParent.offsetHeight - top - playButtonEl.offsetHeight;
			overlapBottom.style.height = px(bottom);
			overlapLeft.style.width = leftPx;
		},

		initializeTracking() {
			if (this.videoDetails.isYoutubeVideo && !this.initializedTracking) {
				this.initializedTracking = true;
				this.tealiumVideoDestroy = this.tealiumTrackYouTubeVideo(this.$refs.videoIframe, {
					playerCallback: (player) => {
						player.addEventListener('onStateChange', this.playerOnStateChange);
					},
				});
			}
		},

		playerOnStateChange({ data: state }) {
			if (state < 0) return;
			this.showIframe = true;
		},

		timeUpdate(e) {
			const { currentTime } = e.target;
			const { headingsAnimatedContainer } = this.$refs;
			const { headingAnimatedNormalized } = this;
			if (!headingsAnimatedContainer || !headingAnimatedNormalized) return;
			const headingsAnimated = headingsAnimatedContainer.children;

			headingAnimatedNormalized.forEach(({ timingsParsed }, index) => {
				const heading = headingsAnimated[index];
				if (!heading) return;
				if (currentTime >= timingsParsed[0] && currentTime < timingsParsed[1]) {
					headingsAnimated[index].dataset.visible = true;
				} else {
					delete headingsAnimated[index].dataset.visible;
				}
			});
		},

		videoUrl(url) {
			const videoUrl = decodeURIComponent(url);
			if (videoUrl.startsWith('https://molekule.cdn.prismic.io/')) {
				const videoFile = videoUrl.split('/');
				return '/prismic-images/molekule/' + videoFile[videoFile.length - 1];
			}
			return url;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.blockIframeWrapper,
.blockIframeWrapper iframe,
.contentWrapper,
.videoWrapper {
	position: absolute;
	top: 0;
	left: 0;
	width: 100%;
	height: 100%;
}

.video {
	object-fit: cover;

	&::-webkit-media-controls {
		display: none !important;
	}

	width: 100%;
	height: 100%;
}

.overlap {
	position: absolute;

	.showIframe & {
		display: none;
	}

	&.top {
		top: 0;
		left: 0;
		width: 100%;
	}

	&.right {
		top: 0;
		right: 0;
		height: 100%;
	}

	&.bottom {
		bottom: 0;
		left: 0;
		width: 100%;
	}

	&.left {
		top: 0;
		left: 0;
		height: 100%;
	}
}

.contentWrapper {
	display: flex;
	flex-direction: column;
	justify-content: center;
	pointer-events: none;
	// I think some browsers may not pass click to iframe with full opacity
	opacity: 0.99;

	.showIframe & {
		display: none;
	}
}

.block {
	position: relative;
	height: 60rem;
	padding: 0 size('s');
	overflow: hidden;
	text-align: center;
	background-color: color('black');

	&.hasMobileVideo {
		@include below('medium') {
			height: auto;
			padding-bottom: var(--padding-bottom);
		}
	}

	@include above('medium') {
		height: auto;
		padding-bottom: var(--padding-bottom-medium);
	}
}

.spacing {
	@include above('xlarge') {
		margin: 0 7rem;
	}
}

.info {
	position: relative;
	z-index: 1;
}

.heading,
.headingAnimatedText {
	@include font-family('secondary');
	@include use-text-style('heading-500');

	max-width: 96rem;
	margin: 0 auto;
	line-height: 1.1765;
	text-align: center;
	white-space: pre-line;

	@include above('medium') {
		@include use-text-style('heading-700');
	}

	@include above('xlarge') {
		@include use-text-style('heading-900');
	}
}

.heading {
	margin-bottom: size('m');

	@include above('xlarge') {
		margin-bottom: size('l');
	}

	&:not(.hasDesktop) {
		@include above('medium') {
			display: none;
		}
	}

	&:not(.hasMobile),
	.hasMobileVideo.hasAnimatedHeading & {
		@include below('medium') {
			display: none;
		}
	}
}

.headingInner {
	&.mobile {
		@include above('medium') {
			display: none;
		}
	}

	&.desktop {
		@include below('medium') {
			display: none;
		}
	}
}

.description {
	max-width: 40rem;
	margin: 0 auto size('m');
}

.button {
	width: 5rem;
	height: 5rem;
	background-color: color('white');
	border-radius: 50%;

	.playButtonLowerOnDesktop & {
		@include above('medium') {
			margin-top: 20rem;
		}
	}
}

.buttonWithTextWrapper {
	position: relative;
	z-index: 1;
	display: flex;
	justify-content: center;
	width: 100%;
	margin-top: size('xxl');

	&.hasLink {
		> * {
			pointer-events: auto;
		}
	}
}

.headingsAnimated {
	position: relative;
	display: none;

	.hasMobileVideo & {
		@include below('medium') {
			display: block;
			min-height: size('s++');
		}
	}

	.hasVideo & {
		@include above('medium') {
			display: block;
			min-height: size('xxl');
		}
	}
}

.headingAnimated {
	position: absolute;
	top: 0;
	left: 0;
	z-index: 1;
	display: flex;
	align-items: center;
	justify-content: center;
	width: 100%;
	height: 100%;
	padding: size('s');
	opacity: 0;
	transition: opacity 0.125s ease-out;

	&[data-visible='true'] {
		opacity: 1;
		transition-timing-function: ease-in;
	}
}

.hideBelowMedium {
	@include below('medium') {
		display: none;
	}
}
</style>
